
set xact_abort on
BEGIN TRAN


USE [{Variable_TempDb}]
GO

----     
IF exists(select 1 from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[dbo].[__JOURNAL_CHARACTERISTICS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].[dbo].[__JOURNAL_CHARACTERISTICS]
GO

CREATE TABLE [dbo].[__JOURNAL_CHARACTERISTICS] (
	[] varchar(max) ,
	[] VARCHAR(MAX) ,
	[] VARCHAR(MAX))
GO
----

--   
USE [{Variable_TempDb}]
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__CHARACTERISTICS_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__CHARACTERISTICS_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__CHARACTERISTICS_SMETA_KS]
GO
  
IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[CHARACTERISTICS]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[CHARACTERISTICS] DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[CHARACTERISTICS] ADD [LINK_OLD] INT NULL
GO

--   [NAME]
INSERT INTO [{Variable_TempDb}].[dbo].[__CHARACTERISTICS_SMETA_KS] ([LINK_NEW], [LINK_OLD])
SELECT 
	[LINK_NEW] = P.LINK,
	[LINK_OLD] = D.[LINK]
FROM 
	{Variable_SmetaDb}.[dbo].[CHARACTERISTICS] D
	INNER JOIN 
	(
		SELECT 
			LINK, NAME, NUM = ROW_NUMBER() OVER (PARTITION BY NAME ORDER BY LINK)
		FROM
			[{Variable_WorkDb}].[dbo].[CHARACTERISTICS]
		WHERE
			LINK_DEP = {LINK_DEP_MAIN}
	) P ON P.NUM = 1 AND LTRIM(RTRIM(P.[NAME])) = LTRIM(RTRIM(LEFT(D.[NAME] {WORK_COLLATE},100)))
WHERE
	ISNULL(LEFT(D.[NAME] {WORK_COLLATE},100),'') <> ''	
	AND
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__CHARACTERISTICS_SMETA_KS] T WHERE T.LINK_OLD = D.LINK)		

--   [CODE]
INSERT INTO [{Variable_TempDb}].[dbo].[__CHARACTERISTICS_SMETA_KS] ([LINK_NEW], [LINK_OLD])
SELECT 
	[LINK_NEW] = P.LINK,
	[LINK_OLD] = D.[LINK]
FROM 
	{Variable_SmetaDb}.[dbo].[CHARACTERISTICS] D
	INNER JOIN 
	(
		SELECT 
			LINK, [CODE], NUM = ROW_NUMBER() OVER (PARTITION BY [CODE] ORDER BY LINK)
		FROM
			[{Variable_WorkDb}].[dbo].[CHARACTERISTICS]
		WHERE
			LINK_DEP = {LINK_DEP_MAIN}
	) P ON P.NUM = 1 AND LTRIM(RTRIM(P.[CODE])) = LTRIM(RTRIM(LEFT(D.[CODE] {WORK_COLLATE},20)))
WHERE
	ISNULL(LEFT(D.[CODE] {WORK_COLLATE},20),'') <> ''
	AND
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__CHARACTERISTICS_SMETA_KS] T WHERE T.LINK_OLD = D.LINK)	

---
DECLARE @iROWS_NOT_COPIED INT

INSERT INTO [{Variable_TempDb}].[dbo].[__JOURNAL_CHARACTERISTICS] ([], [], [])
SELECT 
	[CODE], [NAME], '      '
FROM 
	{Variable_SmetaDb}.[dbo].[CHARACTERISTICS]

SET @iROWS_NOT_COPIED = @@ROWCOUNT

---
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = 0

--    
INSERT INTO [{Variable_WorkDb}].[dbo].[CHARACTERISTICS]
	(CODE, NAME, [TYPE], [LENGTH], [OBJECT], [SYSTEM], DEF_VAL, LINK_DEP, [LINK_OLD])
OUTPUT INSERTED.LINK, INSERTED.[LINK_OLD]
	INTO [{Variable_TempDb}].[dbo].[__CHARACTERISTICS_SMETA_KS]
SELECT
	LEFT(H.[CODE],20), 
	LEFT(H.[NAME],100), 
	H.[TYPE],
	H.[LENGTH],
	[OBJECT]    = NULL, 
	[SYSTEM]    = 0, 
	DEF_VAL     = NULL, 
	LINK_DEP    = {LINK_DEP_MAIN},
	[LINK_OLD]	= H.[LINK]
FROM 
	{Variable_SmetaDb}.[dbo].[CHARACTERISTICS] H
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__CHARACTERISTICS_SMETA_KS] T WHERE T.LINK_OLD = H.LINK)

SET @iROWCOUNT = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '__JOURNAL_CHARACTERISTICS', @iROWS_NOT_COPIED)	


IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[CHARACTERISTICS]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[CHARACTERISTICS] DROP COLUMN [LINK_OLD]
	END
GO

--     
INSERT INTO [{Variable_WorkDb}].[dbo].GROUP_CHARS
	(LINK_CHAR, LINK_GROUP, ACTUAL)
SELECT DISTINCT
    LINK_CHAR = T.[LINK_NEW],
    LINK_GROUP = ISNULL(gasks.LINK_NEW,(SELECT TOP 1 LINK FROM [{Variable_WorkDb}].[dbo].GROUP_ACTIVE WHERE ACCOUNT_B = sa2.LINK)),
    ACTUAL = gc.ACTUAL
FROM 
	{Variable_SmetaDb}.[dbo].GROUP_CHARS gc
	INNER JOIN {Variable_SmetaDb}.[dbo].[CHARACTERISTICS] c ON c.LINK = gc.LINK_CHAR
	INNER JOIN [{Variable_TempDb}].[dbo].[__CHARACTERISTICS_SMETA_KS] T ON T.[LINK_OLD] = C.[LINK]
	LEFT JOIN [{Variable_TempDb}].[dbo].[__GROUP_ACTIVE_SMETA_KS] gasks ON gasks.LINK_OLD = gc.LINK_GROUP
	LEFT JOIN {Variable_SmetaDb}.[dbo].GROUP_INV gi ON gi.LINK = gc.LINK_GROUP
	LEFT JOIN {Variable_SmetaDb}.[dbo].S_ACCOUNTS sa ON sa.LINK = gi.ACCOUNT
	LEFT JOIN [{Variable_WorkDb}].[dbo].S_ACCOUNTS sa2 ON sa2.CODE = sa.CODE {WORK_COLLATE} AND sa2.LINK_DEP = {LINK_DEP_MAIN}
WHERE 
	ISNULL(gasks.LINK_NEW,(SELECT TOP 1 LINK FROM [{Variable_WorkDb}].[dbo].GROUP_ACTIVE WHERE ACCOUNT_B = sa2.LINK)) IS NOT NULL
	AND 
	NOT EXISTS (SELECT 1 FROM [{Variable_WorkDb}].[dbo].GROUP_CHARS 
					WHERE LINK_CHAR = T.[LINK_NEW] AND LINK_GROUP = ISNULL(gasks.LINK_NEW,(SELECT TOP 1 LINK FROM [{Variable_WorkDb}].[dbo].GROUP_ACTIVE WHERE ACCOUNT_B = sa2.LINK)))
GO


COMMIT TRAN
