
set xact_abort ON

USE [{Variable_WorkDb}]
GO

--   
IF COLUMNPROPERTY(object_id('[dbo].[ADMIN_BS]'), 'DATEB', 'AllowsNull') = 0
   ALTER TABLE [dbo].[ADMIN_BS] ALTER COLUMN DATEB DATETIME NULL
GO

IF COLUMNPROPERTY(object_id('[dbo].[ADMIN_BS]'), 'DATEE', 'AllowsNull') = 0
   ALTER TABLE [dbo].[ADMIN_BS] ALTER COLUMN DATEE DATETIME NULL
GO

USE [{Variable_TempDb}]
GO
BEGIN TRAN
---
IF not exists(select * from sysobjects where id = object_id('[dbo].[__ADMIN_BS_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__ADMIN_BS_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__ADMIN_BS_SMETA_KS]

GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[DEPARTMENTS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[DEPARTMENTS] DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[DEPARTMENTS] ADD [LINK_OLD] INT NULL
GO


DECLARE @iLINK_DEP_MAIN INT
SELECT @iLINK_DEP_MAIN = [{Variable_WorkDb}].dbo.getOwnDepLink()

INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS WITH (ROWLOCK) (
 	-- LINK -- this column value is auto-generated
 	CODE,
 	[NAME],
 	FULL_NAME,
 	INN,
 	KPP,
 	OKPO,
 	KLADR_LINK,
 	HOUSE,
 	FLAT,
 	VED_LINK,
 	MAIN_LINK,
 	REGCODE,
 	OKATO,
 	FIN_CODE,
 	TOFK_LINK,
 	PFNUMBER,
 	BUDG,
 	BRON,
 	PREFIX,
 	OGRN,
 	IMNS_LINK,
 	ORD_HEAD,
 	SBK_REGNUM,
 	SBK_DOCNUM,
 	SBK_DOCDATE,
 	SBK_LINK,
 	ZB,
 	HIGH_LINK,
 	PERS_LINK,
 	INN_DOP,
 	IS_RBS,
 	FO_LINK,
 	N_ACC_LINK,
 	EGRUL,
 	CODE_UBP,
 	FSS_REG_NUM,
 	FSS_KOD_P,
 	FSS_KOD_DOP,
 	OKOPF,
 	OKFS,
 	TFOMS_REG_NUM,
 	TFOMS_KT,
 	EMail,
 	FSS_KP_P1,
 	FSS_KP_P2,
 	FSS_KP_P3,
 	CORP,
 	UCHR_LINK,
 	CODE_TOFK,
 	PHONE,
 	-- STAMP -- this column value is auto-generated
 	[GUID],
 	ROW_ID,
 	[ACTION],
 	[TYPE],LINK_DEP,LINK_OLD) 
OUTPUT INSERTED.LINK, INSERTED.LINK_OLD
 	 INTO [{Variable_TempDb}].[dbo].[__ADMIN_BS_SMETA_KS]
SELECT 
	CODE          = RIGHT(ISNULL(LTRIM(RTRIM( ab.Code )),''),10), 
	[NAME]        = CASE WHEN LEN (ISNULL(LTRIM(RTRIM( ab.Name )),'')) = 0 THEN '-'
						ELSE LEFT(ISNULL(LTRIM(RTRIM( ab.Name )),''),50)
					END,
	FULL_NAME     = CASE WHEN LEN (ISNULL(LTRIM(RTRIM( ab.Name )),'')) = 0 THEN '-'
						ELSE LEFT(ISNULL(LTRIM(RTRIM( ab.Name )),''),254)
					END,
	INN           = '',
 	KPP           = '',
 	OKPO          = '',
 	KLADR_LINK    = NULL,
 	HOUSE         = '',
 	FLAT          = '',
 	VED_LINK      = NULL,
 	MAIN_LINK     = NULL,
 	REGCODE       = '',
 	OKATO         = '',
 	FIN_CODE      = '',
 	TOFK_LINK     = NULL,
 	PFNUMBER      = '',
 	BUDG          = '',
 	BRON          = 0,
 	PREFIX        = '',
 	OGRN          = '',
 	IMNS_LINK     = NULL,
 	ORD_HEAD      = '',
 	SBK_REGNUM    = NULL,
 	SBK_DOCNUM    = '',
 	SBK_DOCDATE   = NULL,
 	SBK_LINK      = NULL,
 	ZB            = NULL,
 	HIGH_LINK     = NULL,
 	PERS_LINK     = NULL,
 	INN_DOP       = '',
 	IS_RBS        = 0,
 	FO_LINK       = NULL,
 	N_ACC_LINK    = NULL,
 	EGRUL         = '',
 	CODE_UBP      = '',
 	FSS_REG_NUM   = '',
 	FSS_KOD_P     = '',
 	FSS_KOD_DOP   = '',
 	OKOPF         = '',
 	OKFS          = '',
 	TFOMS_REG_NUM = '',
 	TFOMS_KT      = '',
 	EMail         = '',
 	FSS_KP_P1     = NULL,
 	FSS_KP_P2     = NULL,
 	FSS_KP_P3     = NULL,
 	CORP          = '',
 	UCHR_LINK     = NULL,
 	CODE_TOFK     = '',
 	PHONE         = '',
 	[GUID]        = NULL,
 	ROW_ID        = NULL,
 	[ACTION]      = NULL,
 	[TYPE]        = 0,
 	[LINK_DEP]    = @iLINK_DEP_MAIN,
 	LINK_OLD      = ab.Link
FROM 
	{Variable_SmetaDb}.dbo.KL_ADMIN_BS ab
WHERE --  ,       
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DEPARTMENTS_TYPE_FN(10) G 
					WHERE 
						G.LINK_DEP = @iLINK_DEP_MAIN 
						AND 
						RIGHT(ISNULL(LTRIM(RTRIM(G.CODE)),''),10) = RIGHT(ISNULL(LTRIM(RTRIM( ab.Code {WORK_COLLATE} )),''),10)
				)

--
DECLARE @iROWCOUNT INT
set @iROWCOUNT = @@ROWCOUNT

--
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "   (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)

--  
INSERT INTO [{Variable_WorkDb}].dbo.ADMIN_BS (LINK_UP,BUDG_LINK,DATEB,DATEE)
SELECT
    LINK_UP       = AL.LINK_NEW,
    BUDG_LINK     = NULL,
    DATEB         = NULL,
    DATEE         = NULL
FROM [{Variable_TempDb}].[dbo].[__ADMIN_BS_SMETA_KS] al
INNER JOIN {Variable_SmetaDb}.dbo.KL_ADMIN_BS kab ON kab.LINK = al.LINK_OLD

--
DECLARE @iGROUP_LINK INT
SELECT @iGROUP_LINK = link FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg
WHERE dg.SYS = 10

--
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF WITH (ROWLOCK) (DEP_LINK, GROUP_LINK) 
SELECT al.link_NEW, @iGROUP_LINK
FROM [{Variable_TempDb}].[dbo].[__ADMIN_BS_SMETA_KS] al

--     ,   
INSERT INTO [{Variable_TempDb}].[dbo].[__ADMIN_BS_SMETA_KS] (LINK_OLD,LINK_NEW)
SELECT AB.LINK, MIN(G.LINK)
FROM
	{Variable_SmetaDb}.dbo.KL_ADMIN_BS ab
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_TYPE_FN(10) G ON RIGHT(ISNULL(LTRIM(RTRIM(G.CODE)),''),10) = RIGHT(ISNULL(LTRIM(RTRIM( ab.Code {WORK_COLLATE} )),''),10)
WHERE
	G.LINK_DEP = @iLINK_DEP_MAIN
	AND
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__ADMIN_BS_SMETA_KS] A WHERE A.LINK_OLD = AB.LINK)
GROUP BY
	AB.LINK	
		
ALTER TABLE [{Variable_WorkDb}].[dbo].[DEPARTMENTS] DROP COLUMN [LINK_OLD]
GO

COMMIT TRAN


