
-- 
set xact_abort on
BEGIN TRAN
--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_DOGOVOR_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV_DOGOVOR_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__G_PROV_DOGOVOR_SMETA_KS]
GO


USE {Variable_WorkDb}
GO
---
IF COLUMNPROPERTY(object_id('[{Variable_WorkDb}].[dbo].[G_PROV]'), 'LINK_OLD', 'AllowsNull') IS NOT NULL
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [LINK_OLD] INT NULL
GO
USE {Variable_TempDb}
GO

DECLARE @iLINK INT, @iError INT, @iOBJECT INT, @iACC INT

SELECT @iOBJECT = [{Variable_WorkDb}].dbo.obj_id('FINANS_CONTRACT')

---
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV WITH (ROWLOCK) (NUMBER, DATE, [OBJECT],
            DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC, GUID, [LINK_OLD])
 OUTPUT INSERTED.LINK,INSERTED.[LINK_OLD]
 INTO [{Variable_TempDb}].dbo.[__G_PROV_DOGOVOR_SMETA_KS]
 
SELECT 
NUMBER          = RIGHT(RTRIM(g.NUMBER),30)
,DATE           = g.DATE
,[OBJECT]       = @iOBJECT
,DATE_PROV      = NULL
,SUMMA          = g.SUMMA
,COMMENT        = LEFT(LTRIM(RTRIM(fch.MAINTENANCE)),254)
,GET_STORE      = 0
,DEP            = dsks.LINK_NEW
,ACC            = asks.LINK_NEW
,[GUID]         = NULL
,[LINK_OLD]     = g.LINK
FROM {Variable_SmetaDb}.dbo.G_PROV g
INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS so ON so.LINK = g.[OBJECT] AND so.CODE {WORK_COLLATE} = 'FINANS_CONTRACT' 
INNER JOIN {Variable_SmetaDb}.dbo.FINANSE_CONTRACT_HEAD fch ON g.LINK = fch.Link_G_Prov
LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = g.DEP
LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON d.LINK = dsks.LINK_NEW

LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS] asks ON asks.LINK_OLD = g.ACC


SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END

---
--- 
INSERT INTO [{Variable_WorkDb}].dbo.FINANSE_CONTRACT_HEAD WITH (ROWLOCK) (LINK_UP, CON_PAY,
            DATE_BEGIN, DATE_END, DATE_ACCEPT, DATE_NA, SUMMA_F,
            DOG_LINK, NUMBER_BO, FIN_SOURCE, [TYPE], GZ, GZ_LINK, GZ_NUM, GZ_DATE,PROJECT)
SELECT 
LINK_UP         = gp.LINK_NEW
,CON_PAY        = fch.CON_PAY
,DATE_BEGIN     = fch.DATE_BEGIN
,DATE_END       = fch.DATE_END
,DATE_ACCEPT    = fch.DATE_ACCEPT
,DATE_NA        = fch.DATE_NA
,SUMMA_F        = fch.SUMMA_F
,DOG_LINK       = NULL
,NUMBER_BO      = ISNULL(fch.NUMBER_BO,'')
,FIN_SOURCE     = fch.FIN_SOURCE
,[TYPE]         = fch.[TYPE]
,GZ             = fch.GZ
,GZ_LINK        = NULL
,GZ_NUM         = ''
,GZ_DATE        = NULL
,PROJECT		= 0
FROM 
	{Variable_SmetaDb}.dbo.G_PROV g
	INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS so ON so.LINK = g.[OBJECT] AND so.CODE {WORK_COLLATE} = 'FINANS_CONTRACT' 
	LEFT JOIN [{Variable_TempDb}].dbo.__G_PROV_DOGOVOR_SMETA_KS gp ON gp.LINK_OLD = g.LINK
	LEFT JOIN {Variable_SmetaDb}.dbo.FINANSE_CONTRACT_HEAD fch ON fch.Link_G_Prov = g.LINK

INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_CORR 
	(LINK_UP,SUPPLIER_LINK,BUYER_LINK)
SELECT DISTINCT
	LINK_UP         = gp.LINK_NEW,
	SUPPLIER_LINK   = dsks.LINK_NEW,
	BUYER_LINK      = NULL
FROM 
	{Variable_SmetaDb}.dbo.FINANS_CONTRACT g
	LEFT JOIN [{Variable_TempDb}].dbo.__G_PROV_DOGOVOR_SMETA_KS gp ON gp.LINK_OLD = g.LINK
	LEFT JOIN 
	(SELECT RowNumber = ROW_NUMBER () OVER (PARTITION BY d.LINK_OLD ORDER BY d.LINK_OLD),*
	 FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] d) dsks ON dsks.LINK_OLD = g.DEP_LINK_P
WHERE dsks.RowNumber = 1

---
DECLARE @iROWCOUNT INT
set @iROWCOUNT = @@ROWCOUNT


INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "   (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
---

INSERT INTO [{Variable_WorkDb}].dbo.FINANSE_CONTRACT
(LINK_UP, RECORD_NO, RECORD_CH_NO, VKR, EKR, P1, P2, P3, P4, P5, P6, P7, P8, P9,
P10, P11, P12, DOP_CLASSIF, OKDP, QUANTITY, COST, SUMMA, SOURCE, KAU_LINK,
KL_REG_LINK, NOMEN, [STAVKA_NDS], [NO_NDS], [SUMMA_NDS], [SUMMA_ALL])
SELECT
LINK_UP         = gpdsks.LINK_NEW,
RECORD_NO       = LTRIM(RTRIM(fc.RECORD_NO)),
RECORD_CH_NO    = LTRIM(RTRIM(fc.RECORD_CH_NO)),
VKR             = kksk.LINK_NEW,
EKR             = k2.LINK,
P1              = fc.P1,
P2              = fc.P2,
P3              = fc.P3,
P4              = fc.P4,
P5              = fc.P5,
P6              = fc.P6,
P7              = fc.P7,
P8              = fc.P8,
P9              = fc.P9,
P10             = fc.P10,
P11             = fc.P11,
P12             = fc.P12,
DOP_CLASSIF     = dcsks.LINK_NEW,--dc2.LINK,
OKDP            = o2.LINK,
QUANTITY        = fc.QUANTITY,
COST            = fc.COST,
SUMMA           = fc.SUMMA,
SOURCE          = fs.LINK,
KAU_LINK        = NULL,
KL_REG_LINK     = NULL,
NOMEN           = NULL,
[STAVKA_NDS]=0, 
[NO_NDS]=0, 
[SUMMA_NDS]=0, 
[SUMMA_ALL]=0
FROM 
	{Variable_SmetaDb}.dbo.FINANSE_CONTRACT fc
	INNER JOIN [{Variable_TempDb}].dbo.__G_PROV_DOGOVOR_SMETA_KS gpdsks ON gpdsks.LINK_OLD = fc.LINK_UP
	LEFT JOIN [{Variable_TempDb}].dbo.__KL_KBK_SMETA_KS kksk ON kksk.LINK_OLD = fc.VKR
	LEFT JOIN {Variable_SmetaDb}.dbo.KOSGU k ON k.LINK = fc.EKR
	LEFT JOIN [{Variable_WorkDb}].dbo.KOSGU k2 ON k2.CODE = k.CODE {WORK_COLLATE}

--	LEFT JOIN {Variable_SmetaDb}.dbo.DOP_CLASSIF dc ON dc.LINK = fc.DOP_CLASSIF
--	LEFT JOIN [{Variable_WorkDb}].dbo.DOP_CLASSIF dc2 ON dc2.CODE = dc.CODE {WORK_COLLATE}
	
	LEFT JOIN [{Variable_TempDb}].dbo.[__DOP_CLASSIF_SMETA_KS] dcsks ON dcsks.LINK_OLD = fc.DOP_CLASSIF

	LEFT JOIN {Variable_SmetaDb}.dbo.OKDP o ON o.LINK = fc.OKDP
	LEFT JOIN [{Variable_WorkDb}].dbo.OKDP o2 ON o2.CODE = o.CODE {WORK_COLLATE}

	LEFT JOIN [{Variable_WorkDb}].dbo.FIN_SOURCE fs ON fs.CODE = '0'

---

ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
GO

COMMIT TRAN

