
-- 
set xact_abort on
BEGIN TRAN
--   

USE [{Variable_WorkDb}]


IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].dbo.__DEPARTMENTS_SMETA_KS A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK_NEW
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = GETDATE()
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]
GO


USE {Variable_TempDb}
GO

-- 
--   
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_SMETA_KS_DOCUMENTS_RKO]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV_SMETA_KS_DOCUMENTS_RKO] (
	[LINK_NEW] int ,
	[LINK_OLD] int,
	[DATE] datetime)
ELSE
	IF COLUMNPROPERTY(object_id('[dbo].[__G_PROV_SMETA_KS_DOCUMENTS_RKO]'), 'DATE', 'AllowsNull') is NULL
		ALTER TABLE [dbo].[__G_PROV_SMETA_KS_DOCUMENTS_RKO] ADD [DATE] datetime
GO

IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__G_PROV_SMETA_KS_DOCUMENTS_RKO')
CREATE INDEX [IX__G_PROV_SMETA_KS_DOCUMENTS_RKO] ON [dbo].[__G_PROV_SMETA_KS_DOCUMENTS_RKO] (LINK_OLD)-- ON [INDEX]
GO

USE [{Variable_WorkDb}]
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW ADD [LINK_OLD] INT NULL
GO

DECLARE @iOBJECT INT, @iError INT
SELECT @iOBJECT = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so WHERE so.CODE = 'DOCUMENTS_RKO'

DECLARE @dDATE DATETIME, @DATE_CONV DATETIME, @iROWCOUNT INT
SET @dDATE = DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   
SET @DATE_CONV = GETDATE()

--   ,    
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV
(NUMBER, DATE, [OBJECT], DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC, LINK_OLD)
    OUTPUT INSERTED.LINK,INSERTED.LINK_OLD, @DATE_CONV
		 INTO {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_DOCUMENTS_RKO]

---
SELECT DISTINCT
	 NUMBER     = LTRIM(RTRIM(g.NUMBER))
	,DATE       = G.[DATE]
	,[OBJECT]   = @iOBJECT
	,DATE_PROV  = NULL
	,SUMMA      = G.SUMMA
	,COMMENT    = G.COMMENT
	,GET_STORE  = 0
	,DEP        = dsks.LINK_NEW
	,ACC        = accks.LINK_NEW
	,LINK_OLD   = G.LINK
FROM
	{Variable_SmetaDb}.dbo.G_PROV G
	INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS SO1 ON SO1.LINK = g.[OBJECT]
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = G.DEP
	LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS] accks ON accks.LINK_OLD = G.ACC
WHERE
	g.DATE >= @dDATE
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_RKO] T WHERE T.LINK_OLD = G.LINK)
	AND SO1.CODE {WORK_COLLATE} = 'DOCUMENTS_RKO'

---
SELECT @iError = @@ERROR, @iROWCOUNT = @@ROWCOUNT
IF @iError <> 0
BEGIN
    ROLLBACK
END

---
--SET @DATE_CONV = (SELECT MAX(DATE) FROM [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_ISSUED])

---
INSERT INTO [{Variable_WorkDb}].[dbo].[KO]
([LINK_UP],[SUBDIV],[DEP],[EMPL],[ACC],[REASON],[ADDTEXT],[NDS],[FOND],[ALSO],[USE_NDS],[OTHER_PAY],[DOC_NAME],
[NDS_LINK],[PR_F_DOC],[REASON_SH_LINK],[DOCBASE_LINK],[KBK_LINK],[FIELD_SHABLON])
SELECT
	[LINK_UP] = C.LINK_NEW
	,[SUBDIV] = subd1.LINK_UP
	,[DEP] = dsks.LINK_NEW
	,[EMPL] = emplks.LINK_NEW
	,[ACC] = sacc.LINK_NEW
	,[REASON] = ISNULL(T.[REASON],'')
	,[ADDTEXT] = T.[ADDTEXT]
	,[NDS] = NULL
	,[FOND] = 0
	,[ALSO] = ''
	,[USE_NDS] = 0
	,[OTHER_PAY] = CASE WHEN T.[OPTION]=4 OR (T.[DOCUM] IS NOT NULL AND T.[DOCUM]<>'') THEN T.[PAYER] END
	,[DOC_NAME] = T.[DOCUM]
	,[NDS_LINK] = NULL
	,[PR_F_DOC] = NULL
	,[REASON_SH_LINK] = NULL
	,[DOCBASE_LINK] = NULL
	,[KBK_LINK] = NULL
	,[FIELD_SHABLON] = NULL
FROM
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_RKO] C
	INNER JOIN {Variable_SmetaDb}.dbo.[DOCUMENTS_RKO] T ON T.[Link] = C.LINK_OLD
	INNER JOIN {Variable_SmetaDb}.dbo.[G_PROV] G ON T.[Link] = G.[LINK]
	LEFT JOIN [{Variable_TempDb}].dbo.[__SUBDIV_SMETA_KS] subd ON subd.LINK_OLD = T.OTDEL_LINK
	LEFT JOIN [{Variable_WorkDb}].dbo.[SUBDIV] subd1 ON subd.LINK_NEW = subd1.LINK
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = T.DEP_LINK
	LEFT JOIN [{Variable_TempDb}].dbo.[__EMPL_SMETA_KS] emplks ON emplks.LINK_OLD = CASE T.[OPTION] WHEN 1 THEN T.FACE_LINK WHEN 3 THEN T.FACE_LINK2 ELSE NULL END
	LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS] sacc ON sacc.LINK_OLD = T.S_ACC_LINK
WHERE
	C.[DATE] = @DATE_CONV

---
SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END


INSERT INTO dbo.G_PROV_CORR
        ( LINK_UP ,
          SUPPLIER_LINK ,
          BUYER_LINK
        )
SELECT
	[LINK_UP] = C.LINK_NEW
	,[SUPPLIER_LINK] = dsks.LINK_NEW
	,[BUYER_LINK] = NULL
FROM
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_RKO] C
	INNER JOIN {Variable_SmetaDb}.dbo.[DOCUMENTS_RKO] T ON T.[Link] = C.LINK_OLD
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = T.[S_LINK]
WHERE
	C.[DATE] = @DATE_CONV AND T.[S_LINK] IS NOT NULL

SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END

---   

DECLARE @iDOC_OPER_1 INT,
		@iDOC_OPER_2 INT,
		@iDOC_OPER_3 INT,
		@iDOC_OPER_4 INT
SELECT TOP 1 @iDOC_OPER_1 = LINK FROM [{Variable_WorkDb}].dbo.DOC_OPERS do WHERE do.CODE = 'DOCUMENTS_KO_EMPL' --
SELECT TOP 1 @iDOC_OPER_2 = LINK FROM [{Variable_WorkDb}].dbo.DOC_OPERS do WHERE do.CODE = 'DOCUMENTS_KO_DEP' --
SELECT TOP 1 @iDOC_OPER_3 = LINK FROM [{Variable_WorkDb}].dbo.DOC_OPERS do WHERE do.CODE = 'DOCUMENTS_KO_BANK' --
SELECT TOP 1 @iDOC_OPER_4 = LINK FROM [{Variable_WorkDb}].dbo.DOC_OPERS do WHERE do.CODE = 'DOCUMENTS_KO_OTHER' --

INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_DOC_OPER (LINK_UP, DOC_OPER)
SELECT
	LINK_UP     = C.LINK_NEW,
	DOC_OPER   = CASE T.[OPTION] WHEN 1 THEN @iDOC_OPER_1 WHEN 2 THEN CASE WHEN T.[S_LINK] IS NOT NULL THEN @iDOC_OPER_2 ELSE @iDOC_OPER_4 END WHEN 3 THEN @iDOC_OPER_3 WHEN 4 THEN @iDOC_OPER_4 END
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_RKO] C
	INNER JOIN {Variable_SmetaDb}.dbo.[DOCUMENTS_RKO] T ON T.[Link] = C.LINK_OLD
WHERE 
	C.[DATE] = @DATE_CONV

---
SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END


INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [LINK_OLD]
	END
GO


USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

COMMIT TRAN
GO