--  
USE [{Variable_TempDb}]
GO

--   
IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENT_GROUPS_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DEPARTMENT_GROUPS_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__DEPARTMENT_GROUPS_SMETA_KS]
	
set xact_abort on
BEGIN TRAN
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENT_GROUPS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENT_GROUPS DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENT_GROUPS ADD [LINK_OLD] INT NULL
GO

--   
INSERT INTO[{Variable_TempDb}].dbo.[__DEPARTMENT_GROUPS_SMETA_KS] ([LINK_NEW],[LINK_OLD]) 
SELECT 
	[LINK_NEW] = P.LINK,
	[LINK_OLD] = D.LINK
FROM 
	(	SELECT LINK, NAME {WORK_COLLATE} AS NAME, NUM = ROW_NUMBER() OVER (PARTITION BY [NAME] ORDER BY LINK) 
		FROM {Variable_SmetaDb}.dbo.DEPARTMENT_GROUPS dg
	) d
	INNER JOIN (
		SELECT LINK, [NAME], NUM = ROW_NUMBER() OVER (PARTITION BY [NAME] ORDER BY LINK)
		FROM [{Variable_WorkDb}].[dbo].DEPARTMENT_GROUPS P 
		WHERE P.[SYS] = 0 AND LINK_DEP = {LINK_DEP_MAIN}
	) P ON P.NUM = 1 AND P.[NAME] = LEFT(d.[NAME],60)
WHERE
	D.NUM = 1	
GO

--    
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS
(SNAME,[NAME],SYS,LINK_DEP,[LINK_OLD])
    OUTPUT INSERTED.LINK,INSERTED.[LINK_OLD]
    INTO [{Variable_TempDb}].dbo.[__DEPARTMENT_GROUPS_SMETA_KS]
SELECT
	SNAME       = left(RTRIM(dg.NAME),10),
	[NAME]      = left(RTRIM(dg.NAME),60),
	SYS         = 0,
	LINK_DEP    = {LINK_DEP_MAIN},
	[LINK_OLD]  = dg.LINK
FROM 
	{Variable_SmetaDb}.dbo.DEPARTMENT_GROUPS dg
WHERE
	NOT EXISTS ( SELECT * FROM [{Variable_TempDb}].dbo.[__DEPARTMENT_GROUPS_SMETA_KS] T WHERE T.[LINK_OLD] = dg.[LINK] )

DECLARE @iROWCOUNT INT
set @iROWCOUNT = @@ROWCOUNT


INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)

--    
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF
(DEP_LINK, GROUP_LINK)
SELECT
	DEP_LINK    = dsk.LINK_NEW,
	GROUP_LINK  = dgsk.LINK_NEW
FROM 
	{Variable_SmetaDb}.dbo.DEPARTMENT_GROUPS_REF dgr
	INNER JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS_SMETA_KS dsk ON dsk.LINK_OLD = dgr.DEP_LINK
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENT_GROUPS_SMETA_KS] dgsk ON dgsk.LINK_OLD = dgr.GROUP_LINK

ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENT_GROUPS DROP COLUMN [LINK_OLD]
GO


COMMIT TRAN