USE [{Variable_WorkDb}]
GO

/*
   "  "
       

SELECT LINK_DEP, CODE, NAME, COUNT(*)
FROM
	dbo.KL_TARGET_ITEM B
GROUP BY
	LINK_DEP, CODE, NAME
HAVING
	COUNT(*) > 1

*/

set xact_abort on
BEGIN TRAN

SET NOCOUNT ON

declare @RID UniqueIdentifier
execute dbo.newrid @RID=@RID output

DECLARE @CODE_ADMIN VARCHAR(254), @NAME VARCHAR(2000), @LINK_DEP INT, @LINK INT

DECLARE @Cur1 CURSOR

SET @Cur1 = CURSOR FORWARD_ONLY

FOR 

	SELECT 
		LINK_DEP, LINK, CODE, NAME
	FROM
		(
		SELECT LINK, LINK_DEP, CODE, NAME, NUM = ROW_NUMBER() OVER (PARTITION BY CODE, NAME ORDER BY LINK)
		FROM
			dbo.KL_TARGET_ITEM A
		WHERE
			EXISTS ( SELECT LINK_DEP, CODE, NAME
						FROM
							dbo.KL_TARGET_ITEM B
						WHERE
							B.LINK_DEP = A.LINK_DEP
							AND
							B.CODE = A.CODE	
							AND
							ISNULL(B.NAME,'') = ISNULL(A.NAME,'')
						GROUP BY
							LINK_DEP, CODE, NAME
						HAVING
							COUNT(*) > 1
					)		
		) T 
	WHERE
		T.NUM = 1	
	
OPEN @Cur1
FETCH NEXT FROM @Cur1 INTO @LINK_DEP, @LINK, @CODE_ADMIN, @NAME
WHILE (@@fetch_status <> -1)
BEGIN
	IF (@@fetch_status <> -2)
	BEGIN

		PRINT @CODE_ADMIN
		
		insert into dbo.sys_link ([rid], [link]) 
		SELECT @RID, T.LINK FROM dbo.KL_TARGET_ITEM T WHERE T.LINK_DEP = @LINK_DEP AND T.CODE = @CODE_ADMIN AND ISNULL(T.NAME,'') = ISNULL(@NAME,'')
		
		exec dbo.XA_MERGE_REC @OBJ_CODE = 'KL_TARGET_ITEM', @nMainLink = @LINK, @RID = @RID
		
		DELETE FROM dbo.sys_link WHERE [rid] = @RID
		
	END

	FETCH NEXT FROM @Cur1 INTO @LINK_DEP, @LINK, @CODE_ADMIN, @NAME
END

CLOSE @Cur1
DEALLOCATE @Cur1

SET NOCOUNT OFF

COMMIT TRAN
GO
