set xact_abort on
BEGIN TRAN


USE [{Variable_WorkDb}]



IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	dbo.DEPARTMENTS_DATE B
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = GETDATE()
FROM
	dbo.DEPARTMENTS_DATE B
	INNER JOIN [dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

-- USE bs_test
--     (NOMEN - INV) --
--      --
-- @INVNUM_MODE	TINYINT = 1 -    
IF OBJECT_ID ('_PROTOKOL_NOMEN_TO_INV') IS NULL
	EXEC ('
	CREATE TABLE dbo._PROTOKOL_NOMEN_TO_INV 
		(
		NOMEN	INT,
		INV		INT,
		DEP		INT,
		INV_CODE	VARCHAR (30),
		NOMEN_CODE	VARCHAR (30)
		)
		')
	
DECLARE
	@LINK		INT,
	@DEP_LINK	INT,
	@NOMEN		INT,
	@ACCOUNT	INT,
	
	@INV_CODE	VARCHAR (30),
	@CODE_GRP	VARCHAR (30),
	@INV		INT,
	@CODE_FS	VARCHAR (1),
	@NOMEN_CODE	VARCHAR (30),
	@NAME		VARCHAR (254),
	@INVNUM_MODE	TINYINT

-- @INVNUM_MODE	TINYINT = 1 -    
SET @INVNUM_MODE = 0
	
DECLARE #CURSOR1 CURSOR LOCAL STATIC 
FOR
	SELECT
		SA.LINK,
		T1.DEP_LINK,
		T1.NOMEN
	FROM dbo.S_ACCOUNTS SA
	INNER JOIN
			(
			SELECT
				DEP_LINK	=	S.DEP_LINK,
				ACCOUNT	=	S.ACCOUNT,
				NOMEN	=	S.NOMEN,
				INV	=	S.INV
			FROM dbo.SALDO S
		
			UNION	
				
			SELECT
				DEP_LINK	=	G.DEP,
				ACCOUNT	=	GAP.ACCOUNT,
				NOMEN	=	GAP.NOMEN,
				INV	=	GAP.INV
			FROM dbo.G_PROV G
			INNER JOIN dbo.G_PROV1 G1 ON (G1.LINK_UP = G.LINK)
			INNER JOIN dbo.G_PROV2 G2 ON (G2.LINK_UP = G1.LINK)
			INNER JOIN dbo.G_PROV_AP GAP ON (GAP.LINK_UP = G2.LINK)
			) AS T1 ON 
				(
				T1.ACCOUNT = SA.LINK
				)
		INNER JOIN dbo.[NOMENCLATURE] N ON N.LINK = T1.NOMEN		
		INNER JOIN [dbo].[GROUP_ACTIVE] GA ON GA.LINK = N.[GROUP_INV]
		INNER JOIN dbo.S_ACCOUNTS SA2 ON SA2.LINK = [ACCOUNT_B]
	WHERE SA.AP_INV = 1
		AND T1.NOMEN IS NOT NULL
		AND T1.INV IS NULL
		AND SA2.cSinth LIKE '10[1-3]'
	GROUP BY
		SA.LINK, T1.DEP_LINK, T1.NOMEN	
				
OPEN #CURSOR1
FETCH FIRST FROM #CURSOR1
	INTO
		@ACCOUNT,
		@DEP_LINK,
		@NOMEN

WHILE @@FETCH_STATUS = 0
BEGIN
	SET @INV_CODE = (
					SELECT
						T1.INV_CODE
					FROM dbo._PROTOKOL_NOMEN_TO_INV T1
					WHERE T1.NOMEN = @NOMEN
						AND T1.DEP = @DEP_LINK)

	IF ISNULL (@INV_CODE, '') = ''
	BEGIN
		SELECT
			@CODE_GRP = GR.CODE_GRP,
			@NOMEN_CODE	=	NOMEN.CODE,
			@NAME = NOMEN.NAME
		FROM dbo.NOMENCLATURE NOMEN
		INNER JOIN dbo.GROUP_ACTIVE GR ON (GR.LINK = NOMEN.GROUP_INV)
		WHERE NOMEN.LINK = @NOMEN
	
		IF @INVNUM_MODE = 1
		BEGIN
			SET @CODE_FS = (
							SELECT
								cSOURCE
							FROM dbo.S_ACCOUNTS
							WHERE LINK = @ACCOUNT	
							)

			EXEC dbo.BV_MASC_INVENTORY_NEXT_CCODE
				@INV_CODE OUTPUT,
				@CODE_GRP,
				@DEP_LINK,
				0, 0, 
				@CODE_FS
		END
		ELSE		
			SET @INV_CODE = @NOMEN_CODE

		INSERT INTO dbo.INVENTORY
			(
			CODE,
			NAME,
			COST,
			DEP_LINK,
			NOMENCLATURE,
			TYPE_INV
			)
		SELECT 
			@INV_CODE,
			@NAME,
			0,
			@DEP_LINK,
			@NOMEN,
			0

		SET @INV = SCOPE_IDENTITY ()
		
		INSERT INTO dbo._PROTOKOL_NOMEN_TO_INV
			(
			NOMEN,
			INV,
			DEP,
			INV_CODE,
			NOMEN_CODE
			)
		SELECT
			@NOMEN,
			@INV,
			@DEP_LINK,
			@INV_CODE,
			@NOMEN_CODE
	END	

	IF ISNULL (@INV, 0) > 0
	BEGIN
		UPDATE dbo.G_PROV_AP
		SET
			NOMEN = NULL,
			INV = @INV
		WHERE NOMEN = @NOMEN	

		UPDATE dbo.SALDO
		SET
			NOMEN = NULL,
			INV = @INV
		WHERE NOMEN = @NOMEN	
	END		
		
	FETCH NEXT FROM #CURSOR1
		INTO
			@ACCOUNT,
			@DEP_LINK,
			@NOMEN
END	

CLOSE #CURSOR1
DEALLOCATE #CURSOR1

--SELECT *
--FROM dbo._PROTOKOL_NOMEN_TO_INV 
GO

EXEC [dbo].X_SALDO_COMMITCHANGES
GO


/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	dbo.DEPARTMENTS_DATE B
	INNER JOIN [dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

COMMIT TRAN
GO
